## nvidia-cuda-toolkit 8.0.44

=== local/cuda-8.0/nvml/example/Makefile ===
ARCH       := $(shell getconf LONG_BIT)
OS         := $(shell cat /etc/issue)
RHEL_OS    := $(shell cat /etc/redhat-release)

# Gets Driver Branch
DRIVER_BRANCH := $(shell nvidia-smi | grep Driver | cut -f 3 -d' ' | cut -f 1 -d '.')

# Location of the CUDA Toolkit
CUDA_PATH ?= "/usr/local/cuda-8.0"

ifeq (${ARCH},$(filter ${ARCH},32 64))
    # If correct architecture and libnvidia-ml library is not found 
    # within the environment, build using the stub library
    
    ifneq (,$(findstring Ubuntu,$(OS)))
        DEB := $(shell dpkg -l | grep cuda)
        ifneq (,$(findstring cuda, $(DEB)))
            NVML_LIB := /usr/lib/nvidia-$(DRIVER_BRANCH)
        else 
            NVML_LIB := /lib${ARCH}
        endif
    endif

    ifneq (,$(findstring SUSE,$(OS)))
        RPM := $(shell rpm -qa cuda*)
        ifneq (,$(findstring cuda, $(RPM)))
            NVML_LIB := /usr/lib${ARCH}
        else
            NVML_LIB := /lib${ARCH}
        endif
    endif

    ifneq (,$(findstring CentOS,$(RHEL_OS)))
        RPM := $(shell rpm -qa cuda*)
        ifneq (,$(findstring cuda, $(RPM)))
            NVML_LIB := /usr/lib${ARCH}/nvidia
        else
            NVML_LIB := /lib${ARCH}
        endif
    endif

    ifneq (,$(findstring Red Hat,$(RHEL_OS)))
        RPM := $(shell rpm -qa cuda*)
        ifneq (,$(findstring cuda, $(RPM)))
            NVML_LIB := /usr/lib${ARCH}/nvidia
        else
            NVML_LIB := /lib${ARCH}
        endif
    endif

    ifneq (,$(findstring Fedora,$(RHEL_OS)))
        RPM := $(shell rpm -qa cuda*)
        ifneq (,$(findstring cuda, $(RPM)))
            NVML_LIB := /usr/lib${ARCH}/nvidia
        else
            NVML_LIB := /lib${ARCH}
        endif
    endif

else
    NVML_LIB := ../../lib${ARCH}/stubs/
    $(info "libnvidia-ml.so.1" not found, using stub library.)
endif

ifneq (${ARCH},$(filter ${ARCH},32 64))
	$(error Unknown architecture!)
endif

CFLAGS  := -I ../../include
LDFLAGS := -lnvidia-ml -L $(NVML_LIB)

example: example.o
	$(CC) $< $(CFLAGS) $(LDFLAGS) -o $@

clean:
	-@rm -f example.o
	-@rm -f example

=== local/cuda-8.0/extras/CUPTI/sample/openacc_trace/Makefile ===
#
# Copyright 2015 NVIDIA Corporation. All rights reserved
#

# CUPTI OpenACC support is only available on Linux x86_64 and ppc64le.

# Point to your PGI OpenACC installation's include directory.
# PGI compiler must be in PATH.
OPENACC_INCLUDE_PATH =

INCLUDES += -I../../include
INCLUDES += -I../../../../include
INCLUDES += -I$(OPENACC_INCLUDE_PATH)

PGCPP       = pgc++
PGCPP_FLAGS = -acc -ta=nvidia:cuda7.0 -Mcuda=nordc -tp=p7 -mp=nonuma -pgf90libs

export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib64
TRACE_LIB = libopenacc_trace.so

all: openacc_app

$(TRACE_LIB): openacc_trace.cpp
	$(PGCPP) $(INCLUDES) -DCUPTI_OPENACC_SUPPORT -fPIC -shared -o $@ $<

openacc_app: $(TRACE_LIB) openacc_app.cpp
	$(PGCPP) $(INCLUDES) $(PGCPP_FLAGS)         \
	-L. -L../../lib64  -lopenacc_trace -lcupti  \
	-o $@ $^

run: $(TRACE_LIB) openacc_app
	ACC_PROFLIB=$(TRACE_LIB) ./openacc_app

clean:
	rm -f $(TRACE_LIB) openacc_app

=== debian/changelog ===
nvidia-cuda-toolkit (8.0.44-4) unstable; urgency=medium

  [ Zhou Mo ]
  * README.Debian: Discuss adding nvcc options regarding PIE when mixing GCC
    and CLANG generated objects, since the defaults differ between the
    compilers.  (Closes: #861878)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 29 May 2017 20:48:54 +0200

nvidia-cuda-toolkit (8.0.44-3) unstable; urgency=medium

  [ Zhou Mo ]
  * Depend on clang-3.8 as default compiler alternative, since CUDA does not
    support GCC-6.  (Closes: #835940)
    Use 'nvcc -ccbin clang-3.8' to compile your CUDA applications.
  * Add NEWS entry for this change.

  [ Andreas Beckmann ]
  * Switch to debhelper compat level 10.
  * Generate debian/g++ from debian/gcc.
  * gcc/g++ wrappers: Report if clang-3.8 could be used instead of gcc/g++.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 20 Jan 2017 20:25:17 +0100

nvidia-cuda-toolkit (8.0.44-2) unstable; urgency=medium

  * Overhaul installation of examples.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 27 Oct 2016 04:05:12 +0200

nvidia-cuda-toolkit (8.0.44-1) experimental; urgency=medium

  [ Andreas Beckmann ]
  * New upstream release 8.0 (Sept 2016).  (Closes: #822434, #695304)
  * Use gzip to compress orig tarballs containing already compressed files.
  * Revert the -D_FORCE_INLINES workaround.
  * gcc-support.patch: Remove, fixed upstream.
  * man-sections.patch, man-typos.patch, man-hyphenation.patch: Refresh.
  * Fix more typos found by Lintian.
  * Update Lintian overrides.
  * Upload to experimental.

  [ Zhou Mo ]
  * SOVERSION bump: 7.5 => 8.0, rename all library packages.
  * Update symbols control files.
  * Ship new binary: gpu-library-advisor.
  * New packages for nppi sub-library series:
    + libnppial8.0: New package for image arithmetic and logic
    + libnppicc8.0: New package for image color conversion
    + libnppicom8.0: New package for image compression
    + libnppidei8.0: New package for image data exchange and initialization
    + libnppif8.0: New package for image filters
    + libnppig8.0: New package for image geometry transforms
    + libnppim8.0: New package for image morphological operations
    + libnppist8.0: New package for image statistics
    + libnppisu8.0: New package for image support
    + libnppitc8.0: New package for image threshold and compare
  * libnvgraph8.0: New package for the nvGRAPH library.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 21 Oct 2016 18:34:36 +0200

nvidia-cuda-toolkit (7.5.18-4) unstable; urgency=medium

  * [ppc64el] Use the no-libcuda1 virtual package on Debian, too, since there
    is no current driver available for ppc64el.
  * Fix more typos found by Lintian.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 07 Sep 2016 13:53:33 +0200

nvidia-cuda-toolkit (7.5.18-3) unstable; urgency=medium

  * d/rules: Add missing build-arch/build-indep targets.  (Closes: #832589)
  * nvcc.profile: Add -D_FORCE_INLINES for better glibc 2.23 support.
    (Closes: #822783)
  * Fix more typos found by Lintian.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 31 Jul 2016 15:50:16 +0200

nvidia-cuda-toolkit (7.5.18-2) unstable; urgency=medium

  * man-typos.patch: Fix more typos.
  * Update Lintian overrides.
  * Bump Standards-Version to 3.9.8 (no changes needed).
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 03 May 2016 02:18:58 +0200

nvidia-cuda-toolkit (7.5.18-1) experimental; urgency=medium

  [ Zhou Mo ]
  * New upstream release 7.5 (Sept 2015).  (Closes: #807579)
  * SOVERSION bump: 7.0 => 7.5, rename all library packages.
  * Update symbols control files.
  * [ppc64el] Adjust location of nvvm/lib.
  * Update Lintian overrides.

  [ Andreas Beckmann ]
  * Refresh man-sections.patch.
  * debian/copyright: Synchronize with updated EULA.txt.
  * Use multiarch substitution in nvcc.profile.
  * gcc-support.patch: New, allow usage of GCC 5.
  * Use gcc-5/g++-5 as preferred compiler.
  * Update documentation regarding the CUDA Code Samples.
  * [ppc64el] Use the no-libcuda1 virtual package on Ubuntu.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Mar 2016 02:12:57 +0100

=== debian/control ===
Source: nvidia-cuda-toolkit
Section: non-free/libs
Priority: extra
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
 Russ Allbery <rra@debian.org>,
 Graham Inggs <ginggs@debian.org>,
 Zhou Mo <cdluminate@gmail.com>,
Build-Depends:
 debhelper (>= 10),
 quilt,
 libncurses5,
 chrpath [ppc64el],
 libexpat1 [ppc64el],
Standards-Version: 3.9.8
Homepage: http://www.nvidia.com/CUDA
Vcs-Svn: svn://anonscm.debian.org/pkg-nvidia/packages/nvidia-cuda-toolkit/trunk
Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-nvidia/packages/nvidia-cuda-toolkit/
XS-Autobuild: yes

Package: nvidia-cuda-toolkit
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 nvidia-profiler (= ${binary:Version}),
 nvidia-cuda-dev (= ${binary:Version}),
 nvidia-opencl-dev (= ${binary:Version}) | opencl-dev,
 clang-3.8 | clang (<< 1:3.9~) | gcc-5 | gcc-4.9 | gcc-4.8,
 clang-3.8 | clang (<< 1:3.9~) | g++-5 | g++-4.9 | g++-4.8,
 ${shlibs:Depends}, ${misc:Depends},
Recommends:
 nvidia-cuda-doc (= ${source:Version}),
 nvidia-cuda-gdb (= ${binary:Version}),
 nvidia-visual-profiler (= ${binary:Version}),
Suggests:
 libcupti-dev,
 nvidia-driver (>= ${nvidia:MinVersion}) [!ppc64el],
Conflicts:
# packages from the repository packages provided by NVIDIA
 cuda-repo-ubuntu1204,
 cuda-repo-ubuntu1404,
 cuda-repo-ubuntu1404-7-5-local,
 cuda-repo-ubuntu1410,
 cuda-repo-ubuntu1504,
 cuda-repo-ubuntu1504-7-5-local,
 cuda-license-7-5,
Description: NVIDIA CUDA development toolkit
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the nvcc compiler and other tools needed for building
 CUDA applications.
 .
 Running CUDA applications requires a supported NVIDIA GPU and the NVIDIA
 driver kernel module.

Package: nvidia-cuda-doc
Section: non-free/doc
Architecture: all
Depends: ${misc:Depends}
Description: NVIDIA CUDA and OpenCL documentation
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the developer documentation.

Package: nvidia-cuda-gdb
Section: non-free/devel
Architecture: amd64 ppc64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version})
Description: NVIDIA CUDA Debugger (GDB)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the cuda-gdb debugger.

Package: nvidia-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 libcuinj64-${cuda:SoVersion},
 ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA Profiler for CUDA and OpenCL
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the nvprof profiler.

Package: nvidia-visual-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 default-jre | java6-runtime,
 libgtk2.0-0,
 nvidia-profiler (= ${binary:Version}),
 ${perl:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version}),
Homepage: http://developer.nvidia.com/nvidia-visual-profiler
Description: NVIDIA Visual Profiler for CUDA and OpenCL
 The NVIDIA Visual Profiler is a cross-platform performance profiling tool
 that delivers developers vital feedback for optimizing CUDA C/C++ and OpenCL
 applications.

Package: nvidia-nsight
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 default-jre | java6-runtime,
 libgtk2.0-0,
 ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version}),
Homepage: http://developer.nvidia.com/cuda/nsight-eclipse-edition
Description: NVIDIA Nsight Eclipse Edition
 NVIDIA Nsight Eclipse Edition is a full-featured IDE powered by the Eclipse
 platform that provides an all-in-one integrated environment to edit, build,
 debug and profile CUDA-C applications.
 Nsight Eclipse Edition supports a rich set of commercial and free plugins.

Package: nvidia-cuda-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el
Depends:
 libcudart${cuda:SoVersion} (= ${binary:Version}),
 libcuinj64-${cuda:SoVersion} (= ${binary:Version}),
 libnvrtc${cuda:SoVersion} (= ${binary:Version}),
 libnvtoolsext1 (= ${binary:Version}),
 libnvvm3 (= ${binary:Version}),
 libcublas${cuda:SoVersion} (= ${binary:Version}),
 libnvblas${cuda:SoVersion} (= ${binary:Version}),
 libcufft${cuda:SoVersion} (= ${binary:Version}),
 libcufftw${cuda:SoVersion} (= ${binary:Version}),
 libcurand${cuda:SoVersion} (= ${binary:Version}),
 libcusolver${cuda:SoVersion} (= ${binary:Version}),
 libcusparse${cuda:SoVersion} (= ${binary:Version}),
 libnppc${cuda:SoVersion} (= ${binary:Version}),
 libnppi${cuda:SoVersion} (= ${binary:Version}),
 libnppial${cuda:SoVersion} (= ${binary:Version}),
 libnppicc${cuda:SoVersion} (= ${binary:Version}),
 libnppicom${cuda:SoVersion} (= ${binary:Version}),
 libnppidei${cuda:SoVersion} (= ${binary:Version}),
 libnppif${cuda:SoVersion} (= ${binary:Version}),
 libnppig${cuda:SoVersion} (= ${binary:Version}),
 libnppim${cuda:SoVersion} (= ${binary:Version}),
 libnppist${cuda:SoVersion} (= ${binary:Version}),
 libnppisu${cuda:SoVersion} (= ${binary:Version}),
 libnppitc${cuda:SoVersion} (= ${binary:Version}),
 libnpps${cuda:SoVersion} (= ${binary:Version}),
 libnvgraph${cuda:SoVersion} (= ${binary:Version}),
 libthrust-dev,
 ${misc:Depends}
Recommends:
 ${package:libcuda1},
 libgl1-mesa-dev | libgl-dev,
 libvdpau-dev,
 libnvcuvid1,
Breaks:
 libcuda1 (<< ${nvidia:MinVersion}),
 libcuinj64-5.5 (<< 5.5.22-6~),
 libcuinj64-6.0 (<< 6.0.37-2~),
Replaces:
 libcuinj64-5.5 (<< 5.5.22-6~),
 libcuinj64-6.0 (<< 6.0.37-2~),
Description: NVIDIA CUDA development files
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the development files: headers and libraries.

Package: nvidia-opencl-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el
Multi-Arch: same
Depends:
 ${package:nvidia-libopencl1},
 opencl-headers (>= 1.2),
 ${misc:Depends}
Recommends:
 libgl1-mesa-dev | libgl-dev,
 nvidia-opencl-icd,
Provides:
 opencl-dev,
Conflicts:
 opencl-dev,
Replaces:
 opencl-dev,
Description: NVIDIA OpenCL development files
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This metapackage provides the development files: headers and libraries.

Package: libcudart8.0
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends:
 ${package:libcuda1}
Provides:
 no-libcuda1 [ppc64el],
Description: NVIDIA CUDA Runtime Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the CUDA Runtime API library for high-level CUDA
 programming, on top of the CUDA Driver API.

Package: libcuinj64-8.0
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA CUINJ Library (64-bit)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 CUINJ is the CUDA internal library for profiling.
 .
 This package contains the 64-bit CUINJ runtime library.

Package: libnvrtc8.0
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CUDA Runtime Compilation (NVIDIA NVRTC Library)
 CUDA Runtime Compilation library (nvrtc) provides an API to compile
 CUDA-C++ device source code at runtime.
 .
 The resulting compiled PTX can be launched on a GPU using the CUDA
 Driver API.
 .
 This package contains the NVRTC library.

Package: libnvtoolsext1
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Homepage: http://http.developer.nvidia.com/ParallelNsight/1.51/UserGuide/HTML/How_To_Use_the_NVIDIA_Tools_Extension_Library_%28nvtx%29.html
Description: NVIDIA Tools Extension Library
 The NVIDIA Tools Extension SDK (NVTX) is a C-based API for marking events and
 ranges in your applications. Applications which integrate NVTX can use Nsight
 to capture and visualize these events and ranges.
 .
 This package contains the NVIDIA Tools Extension runtime library.

Package: libnvvm3
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Homepage: https://developer.nvidia.com/cuda-llvm-compiler
Description: NVIDIA NVVM Library
 NVIDIA's CUDA Compiler (NVCC) is based on the widely used LLVM open source
 compiler infrastructure.
 .
 The NVVM library is used by NVCC to compile CUDA binary code to run on NVIDIA
 GPUs.
 .
 This package contains the NVIDIA NVVM runtime library.

Package: libcupti8.0
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Homepage: http://developer.nvidia.com/cuda-profiling-tools-interface
Description: NVIDIA CUDA Profiler Tools Interface runtime library
 The CUDA Profiler Tools Interface (CUPTI) enables the creation of
 profiling and tracing tools that target CUDA applications.  CUPTI
 provides a set of APIs targeted at ISVs creating profilers and other
 performance optimization tools. The CUPTI APIs are not intended to be
 used by developers in their CUDA applications.
 .
 This package contains the runtime library.

Package: libcupti-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el
Multi-Arch: same
Depends: libcupti${cuda:SoVersion} (= ${binary:Version}), ${misc:Depends}
Recommends: libcupti-doc
Homepage: http://developer.nvidia.com/cuda-profiling-tools-interface
Description: NVIDIA CUDA Profiler Tools Interface development files
 The CUDA Profiler Tools Interface (CUPTI) enables the creation of
 profiling and tracing tools that target CUDA applications.  CUPTI
 provides a set of APIs targeted at ISVs creating profilers and other
 performance optimization tools. The CUPTI APIs are not intended to be
 used by developers in their CUDA applications.
 .
 This package contains the development files: headers and libraries.

Package: libcupti-doc
Section: non-free/doc
Architecture: all
Depends: ${misc:Depends}
Homepage: http://developer.nvidia.com/cuda-profiling-tools-interface
Description: NVIDIA CUDA Profiler Tools Interface documentation
 The CUDA Profiler Tools Interface (CUPTI) enables the creation of
 profiling and tracing tools that target CUDA applications.  CUPTI
 provides a set of APIs targeted at ISVs creating profilers and other
 performance optimization tools. The CUPTI APIs are not intended to be
 used by developers in their CUDA applications.
 .
 This package contains the documentation and examples.

Package: libcublas8.0
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA cuBLAS Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH		?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH	?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
VENDOR			:= $(shell dpkg-vendor --derives-from Ubuntu && echo Ubuntu || echo Debian)

include debian/rules.defs
CUDA_VERSION_TOOLKIT	:= $(shell dpkg-parsechangelog | sed -nr '/^Version:/s/Version: (.*:)?(.*)-(.*)/\2/p')
CUDA_VERSION_MAJOR	?= $(word 1,$(subst ., ,$(CUDA_VERSION_TOOLKIT)))
CUDA_VERSION_MINOR	?= $(word 2,$(subst ., ,$(CUDA_VERSION_TOOLKIT)))
version_driver		 = $(CUDA_VERSION_DRIVER)
watch_url		 = $(if $(CUDA_BETA),$(CUDA_WATCH_URL_BETA),$(CUDA_WATCH_URL))

package_libcuda1 \
	= libcuda1 (>= $${nvidia:MinVersion}) \
	| libcuda-$${cuda:SoVersion}-1
#ifeq ($(VENDOR),Ubuntu)
package_libcuda1	+= | no-libcuda1 [ppc64el]
#endif

package_nvidia-libopencl1 \
	= nvidia-libopencl1 (>= $${nvidia:MinVersion}) \
	| libopencl-1.2-1

# system libdir
libdir			 = usr/lib/$(DEB_HOST_MULTIARCH)

TEMPLATES	:= $(wildcard debian/*.in debian/patches/*.in)
SOVERTEMPLATES	:= $(wildcard debian/*SOVER*)
AUTOGEN         += $(patsubst %.in,%,$(TEMPLATES))
AUTOGEN		+= $(subst SOVER,$(CUDA_SOVERSION),$(sort $(patsubst %.in,%,$(SOVERTEMPLATES))))
AUTOGEN		+= debian/g++
AUTOKEEP	 = debian/watch
AUTOCLEAN	 = $(filter-out $(AUTOKEEP),$(AUTOGEN))
AUTOCLEAN	+= debian/shlibs.local


.PHONY: autogen prepare
autogen: $(AUTOGEN)
prepare: autogen unpack-stamp compare-copyright-license


nvidia-cuda-amd64: debian/rules debian/rules.shuffle
	dh_testdir
	$(RM) -r $@ $@.tmp
	sh $(CUDA_FILENAME.amd64) --noexec --keep --target $@.tmp
	$(MAKE) -C $@.tmp -f ../debian/rules.shuffle shuffle-nvidia-cuda-amd64
	mv $@.tmp $@

nvidia-cuda-ppc64el: debian/rules debian/rules.shuffle
	dh_testdir
	$(RM) -r $@ $@.tmp
	mkdir $@.tmp
	@set -e -x ; for deb in ppc64el/cuda*.deb ; do dpkg -x $$deb $@.tmp/ubuntutree ; done
	$(MAKE) -C $@.tmp -f ../debian/rules.shuffle shuffle-nvidia-cuda-ppc64el
	mv $@.tmp $@

unpack-stamp: nvidia-cuda-$(DEB_HOST_ARCH)
	ln -s nvidia-cuda-$(DEB_HOST_ARCH) nvidia-cuda
	QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	touch $@

# Reformat the EULA to the format needed for debian/copyright.
nvidia-cuda/EULA.txt: unpack-stamp
EULA.fmt: nvidia-cuda/EULA.txt
	cat $<  | fromdos | fromdos | expand \
		| iconv -f CP1255 -t latin1//TRANSLIT \
		| fold -s -w 80 \
		| sed -e 's/ *$$//;s/^$$/./;s/^/ /;' \
		> $@

# Compare the license in debian/copyright with the EULA shipped in the archive.
compare-copyright-license: EULA.fmt
	sed -e '1,/^License: other-NVIDIA-CUDA-TOOLKIT/d; /^$$/,$$d; /^ .$$/d' debian/copyright > copyright.tmp
	sed -e '/^ .$$/d' EULA.fmt > EULA.tmp
	diff -w copyright.tmp EULA.tmp
	rm -f copyright.tmp EULA.tmp


.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install
binary binary-arch build build-arch build-indep clean install:
	dh $@

binary-indep:
	# the documentation packages must be built on amd64 (otherwise some parts are missing)
	test "$(DEB_HOST_ARCH)" = "amd64"
	dh $@

override_dh_auto_configure: $(AUTOGEN) unpack-stamp

override_dh_auto_install:
	mkdir debian/tmp
	cp -al nvidia-cuda-$(DEB_HOST_ARCH) debian/tmp/usr
	chmod -x debian/tmp/usr/libnvvp/*.xpm
	chmod -x debian/tmp/usr/libnsight/*.xpm
	sed -i '/^-vm$$/ d; /^..\/jre\/bin\/java$$/ d' debian/tmp/usr/libnvvp/nvvp.ini debian/tmp/usr/libnsight/nsight.ini
	chmod -x debian/tmp/usr/bin/crt/link.stub
	chmod -x debian/tmp/usr/bin/crt/prelink.stub
	chmod -x debian/tmp/usr/nvvm/include/*.h
	chmod -x debian/tmp/usr/nvvm/libnvvm-samples/build.bat
ifeq ($(DEB_HOST_ARCH),ppc64el)
	chrpath -d debian/tmp/usr/bin/cuda-gdb
endif
	# remove tracking scripts
	rm -rfv debian/tmp/usr/doc/html/common/scripts
	# remove tracking images
	find debian/tmp/usr/doc/html -name '*.html' -exec sed -r -i \
		-e '\,http://omniture.nvidia.com/b/ss/nvidiacudadocs/1/H.17--NS/0, { s,(<noscript>),<!-- \1,; s,img src,img DISABLED,; s,(</noscript>),\1 -->, }' \
		-e 's,(<script type="text/javascript" )src(="http://w.sharethis.com/button/buttons.js"[^>]*></script>),<!-- \1DISABLED\2 -->,' \
		{} +
	find debian/tmp/usr/libnsight debian/tmp/usr/libnvvp -name 'license.html' -exec sed -r -i \
		-e 's,(<script type="text/javascript" )src(="http://w.sharethis.com/button/buttons.js"[^>]*></script>),<!-- \1DISABLED\2 -->,' \
		{} +
	# reduce 'dh_install --list-missing' noise
	rm -rf debian/tmp/usr/include/thrust
	rm -rf debian/tmp/usr/lib32
	rm -rf debian/tmp/usr/*/lib32

override_dh_install:
	dh_install --list-missing
	rm -rf debian/nvidia-visual-profiler/usr/share/nvidia-visual-profiler/plugins/org.eclipse.equinox.launcher.gtk.linux.*
	rm -rf debian/nvidia-nsight/usr/share/nvidia-nsight/plugins/org.eclipse.equinox.launcher.gtk.linux.*

override_dh_installman:
	dh_installman --language=C

override_dh_makeshlibs:
	dh_makeshlibs -X/stubs/

override_dh_shlibdeps:
	mkdir libcuda
	ln -s ../nvidia-cuda/lib/stubs/libcuda.so libcuda/libcuda.so.1
	echo 'libcuda 1 XXXlibcuda1XXX' > debian/shlibs.local
	dh_shlibdeps -X/stubs/ -- -llibcuda
	$(RM) -r libcuda debian/shlibs.local
	sed -i -r 's/XXXlibcuda1XXX/$${package:libcuda1}/g' debian/*.substvars

# running dh_strip is not permitted by the NVIDIA license
override_dh_strip:
override_dh_strip_nondeterminism:

override_dh_compress:
	dh_compress -Xusr/share/doc/nvidia-cuda-doc/examples -Xusr/share/doc/libcupti-doc/examples

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'package:libcuda1=$(package_libcuda1)' \
		-V'package:nvidia-libopencl1=$(package_nvidia-libopencl1)' \
		-V'cuda:SoVersion=$(CUDA_SOVERSION)' \
		-V'nvidia:MinVersion=$(version_driver)'

override_dh_auto_clean:
	$(RM) -r .pc
	$(RM) nvidia-cuda
	$(RM) -r nvidia-cuda-amd64
	$(RM) -r nvidia-cuda-ppc64el
	$(RM) EULA.fmt EULA.tmp copyright.tmp

override_dh_clean:
	dh_clean
	$(RM) $(AUTOCLEAN)
	$(MAKE) -f debian/rules $(AUTOKEEP)


# Generating control files
%:: %.in debian/rules debian/rules.defs
	perl -p \
	-e 's{#VERSION_TOOLKIT#}{$(CUDA_VERSION_TOOLKIT)}g;' \
	-e 's{#SOVERSION#}{$(CUDA_SOVERSION)}g;' \
	-e 's{#CUDA_DOWNLOAD_URL#}{$(watch_url)}g;' \
	-e 's{#LIBDIR#}{$(libdir)}g;' \
	-e 's{#MAN_DATE#}{$(CUDA_MAN_DATE.$(DEB_HOST_ARCH))}g;' \
	< $< > $@

lib%$(CUDA_SOVERSION).install:: lib%SOVER.install
	cp $< $@

lib%$(CUDA_SOVERSION).links:: lib%SOVER.links
	cp $< $@

lib%$(CUDA_SOVERSION).lintian-overrides:: lib%SOVER.lintian-overrides
	cp $< $@

lib%$(CUDA_SOVERSION).symbols:: lib%SOVER.symbols
	cp $< $@

debian/g++: debian/gcc
	sed '/prog=/s/gcc-/g++-/g' < $< > $@
	chmod 0755 $@

# only invoked manually
check-whitespace:
	grep -r --exclude-dir=.svn --exclude-dir=.git --exclude '*.patch' -E '\s$$' debian || true

############################################################################

CACHE			?= ../.cache
ORIGDIR			?= nvidia-cuda-toolkit-$(CUDA_VERSION_TOOLKIT).orig
TARBALL_BASE		?= nvidia-cuda-toolkit_$(CUDA_VERSION_TOOLKIT).orig
TARBALL_SUFFIX		?= .tar.gz
TARBALL			?= $(TARBALL_BASE)$(TARBALL_SUFFIX)
ORIGDIR.amd64		?= $(ORIGDIR)
TARBALL.amd64		?= $(TARBALL)
ORIGDIR.ppc64el		?= $(ORIGDIR)-ppc64el
TARBALL.ppc64el		?= $(TARBALL_BASE)-ppc64el$(TARBALL_SUFFIX)

CUDA_DL_FILENAME.amd64	?= cuda_$(CUDA_VERSION_TOOLKIT)_linux.run
CUDA_DL_FILENAME.ppc64el?= ???

CUDA_URL_FILENAME.amd64		?= $(CUDA_DL_FILENAME.amd64:.run=-run)
CUDA_URL_FILENAME.ppc64el	?= $(CUDA_DL_FILENAME.ppc64el:.deb=-deb)

get-orig-source-prepare:
	$(RM) $(TARBALL)
	$(RM) $(TARBALL.amd64)
	$(RM) $(TARBALL.ppc64el)
	$(RM) -r get-orig-source || true
	mkdir get-orig-source

get-orig-source-download-%: get-orig-source-prepare
	ln -v $(CACHE)/$(CUDA_DL_FILENAME.$*) get-orig-source/ 2>/dev/null || \
		wget $(CUDA_DL_URL_BASE)/$(CUDA_URL_FILENAME.$*) -O get-orig-source/$(CUDA_DL_FILENAME.$*)
	if [ -d $(CACHE) ] && [ ! -f $(CACHE)/$(CUDA_DL_FILENAME.$*) ]; then \
		ln -v get-orig-source/$(CUDA_DL_FILENAME.$*) $(CACHE) ; fi

## nvidia-cuda-toolkit 8.0.61

=== debian/changelog ===
nvidia-cuda-toolkit (8.0.61-1) unstable; urgency=medium

  [ Andreas Beckmann ]
  * New upstream release 8.0 GA2 (Feb 2017).
  * Update symbols control files.
  * Bump Standards-Version to 4.1.1 (no changes needed).
  * Update Lintian overrides.

  [ Russ Allbery ]
  * Remove myself from Uploaders.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 04 Oct 2017 15:15:32 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
 Uploaders:
  Andreas Beckmann <anbe@debian.org>,
- Russ Allbery <rra@debian.org>,
  Graham Inggs <ginggs@debian.org>,
  Zhou Mo <cdluminate@gmail.com>,
 Build-Depends:
@@ -13,7 +12,7 @@
  libncurses5,
  chrpath [ppc64el],
  libexpat1 [ppc64el],
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: http://www.nvidia.com/CUDA
 Vcs-Svn: svn://anonscm.debian.org/pkg-nvidia/packages/nvidia-cuda-toolkit/trunk
 Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-nvidia/packages/nvidia-cuda-toolkit/
@@ -331,3 +330,4 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: NVIDIA cuBLAS Library
  The Compute Unified Device Architecture (CUDA) enables NVIDIA
+ graphics processing units (GPUs) to be used for massively parallel
